// MyConf.h: MyConf NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_MYCONF_H__B9FC4FB9_9FCE_4BE3_92AA_8DE46CDB8436__INCLUDED_)
#define AFX_MYCONF_H__B9FC4FB9_9FCE_4BE3_92AA_8DE46CDB8436__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#define PDELETE(p)	{if(p) delete p;p=NULL;}


#define MAX_CHAR	64

// Server name
#define	MYCONF_WSTR_KEY_SRVNAME	TEXT("ServerSoftware")
#define	MYCONF_STR_SRVNAME		"CEHTTP/2.1"
#define	MYCONF_WSTR_SRVNAME		TEXT(MYCONF_STR_SRVNAME)

// document root
#define MYCONF_WSTR_KEY_DOCROOT	TEXT("DocRoot")
#define	MYCONF_STR_DOCROOT		"\\wwwroot"
#define	MYCONF_WSTR_DOCROOT		TEXT(MYCONF_STR_DOCROOT)

// script root
#define MYCONF_WSTR_KEY_CGIROOT	TEXT("CgiRoot")
#define	MYCONF_STR_CGIROOT		"\\wwwroot\\scripts"
#define	MYCONF_WSTR_CGIROOT		TEXT(MYCONF_STR_CGIROOT)

// default page
#define MYCONF_WSTR_KEY_DEFPAGE	TEXT("DefaultDoc")
#define	MYCONF_STR_DEFPAGE		"index.html"
#define	MYCONF_WSTR_DEFPAGE		TEXT(MYCONF_STR_DEFPAGE)

// basic.cha
#define MYCONF_WSTR_KEY_BAUTHFILE	TEXT("BasicAuthFile")
#define MYCONF_STR_BAUTHFILE		"access.cha"
#define MYCONF_WSTR_BAUTHFILE		TEXT("MYCONF_STR_BAUTHFILE")

// filter
#define MYCONF_WSTR_KEY_MODULE	TEXT("Filter")
#define MYCONF_STR_MODULE		"cehin.fil"
#define MYCONF_WSTR_MODULE		TEXT(MYCONF_STR_FILTER)

// listen port
#define MYCONF_WSTR_KEY_PORT	TEXT("Port")
#define MYCONF_NUM_PORT			80

// timeout for transaction
#define MYCONF_WSTR_KEY_TIMEOUT	TEXT("Timeout")
#define MYCONF_NUM_TIMEOUT		3000

// KEEPALIVE
#define MYCONF_WSTR_KEY_KEEPALIVE	TEXT("KeepAlive")
#define MYCONF_NUM_KEEPALIVE		1

// StartServers
#define MYCONF_WSTR_KEY_SERVERS	TEXT("StartServers")
#define MYCONF_NUM_SERVERS		4


#define MYCONF_WSTR_SUBKEY	TEXT("SOFTWARE\\ISHISOFT\\CEHTTP")

class MyConf  
{
public:
	MyConf();
	virtual ~MyConf();
/*
	char	m_pszServerSoftware[MAX_CHAR];	// = "Ishisoft-CEHTTP/x.x";
	char	m_szDocRootName[MAX_PATH];		// = "\\wwwroot";
	char	m_szCgiRootName[MAX_PATH];		// = "\\wwwroot\\scripts";	// CGIrootDocRootzɂ邱
	char	m_szDefaultDocName[MAX_PATH];	// = "index.html";
*/
	char*	m_pszServerSoftware;			// = "Ishisoft-CEHTTP/x.x";
	char*	m_pszDocRootName;				// = "\\wwwroot";
	char*	m_pszCgiRootName;				// = "\\wwwroot\\scripts";
											// CGIrootDocRootzɂ邱
	char*	m_pszDefaultDocName;			// = "index.html";
	char*	m_pszAccessFileName;			
	int		m_nListenPort;					//	= 80;
	int		m_nStartServers;				//	= 8;
	int		m_nTimeOut;						// = 3000;
	int		m_nKeepAlive;					// = 1(ON)

	LONG ReadTStringValue(TCHAR* tszKey, TCHAR* tszValue, int nValueSize);
	void ReadNumericValue(TCHAR* tszKey, DWORD* pdwValue, DWORD dwDefaultValue);
	void ReadNumericValue(TCHAR* tszKey, int* pdwValue, int dwDefaultValue);
	int ReadStringValue(TCHAR* tszKey, char* szValue, int nValueSieze, char* szDefaultValue);
	BOOL WriteStringValue(TCHAR* tszKey, TCHAR* tszValue);
	BOOL WriteStringValue(TCHAR* tszKey, char* szValue);
	BOOL WriteIntValue(TCHAR* tszKey, int nNumber);

};

#endif // !defined(AFX_MYCONF_H__B9FC4FB9_9FCE_4BE3_92AA_8DE46CDB8436__INCLUDED_)
