/*
	version:merry chiristmas!

 */

#include "stdafx.h"
#include "resource.h"
#include "MySock.h"
#include "MyConf.h"

#include "httpd.h"
#include "httphelper.h"

#include "string.h"

#ifndef WINCE
#include "shellapi.h"
#endif

#define MY_NOTIFYICON	(WM_APP + 1000)
HINSTANCE	g_hInst;
extern MyConf	g_conf;

TCHAR*	szG_VERSION_OF_CEHTTP_CPP = TEXT(__TIMESTAMP__);
extern TCHAR* szG_VERSION_OF_HTTPD_CPP;
extern TCHAR* szG_VERSION_OF_HTTPHELPER_CPP;
extern TCHAR* szG_VERSION_OF_MYCONF_CPP;
extern TCHAR* szG_VERSION_OF_MYHTTPSOCK_CPP;
extern TCHAR* szG_VERSION_OF_MYSOCK_CPP;
extern TCHAR* szG_VERSION_OF_MYTIME_CPP;

BOOL ShowSetting(HWND hDlg);
BOOL SetSetting(HWND hDlg);
BOOL CALLBACK DlgProc(HWND hDlg, UINT Msg, WPARAM wParam, LPARAM lParam);
BOOL CALLBACK SettingDlgProc(HWND hDlg, UINT Msg, WPARAM wParam, LPARAM lParam);
BOOL CALLBACK HelpDlgProc(HWND hDlg, UINT Msg, WPARAM wParam, LPARAM lParam);
BOOL MakeLand(HWND hDlg);


//-----------------------------------------------------------------------------
//	@detail
//		WinMain֐
//	@param
//	@return
//-----------------------------------------------------------------------------
#ifndef _WIN32_WCE
int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow )
#else
int WINAPI WinMain(	HINSTANCE hInstance,
					HINSTANCE hPrevInstance,
					LPTSTR    lpCmdLine,
					int       nCmdShow)
#endif
{
	g_hInst = hInstance;
    DialogBox(hInstance, MAKEINTRESOURCE(IDD_MAINDLG),
              NULL, DlgProc);
    return 0;

}

//-----------------------------------------------------------------------------
//	@detail
//		_CAOC֐
//	@param
//	@return
//-----------------------------------------------------------------------------
BOOL CALLBACK DlgProc(HWND hDlg, UINT Msg, WPARAM wParam, LPARAM lParam)
{
	static	THREADPACK* pListenThreadPack = NULL;
	static	NOTIFYICONDATA	nIcon;
	static	HICON			hIconTaskBar;


	switch(Msg)
	{
	case WM_INITDIALOG:
	{
		SetDlgItemText(hDlg, IDC_TIMESTAMP, TEXT(__TIMESTAMP__));

			
		MySock s;
		//s.InitDll();
		pListenThreadPack = NULL;
		if( !MakeLand(hDlg) )
		{
			DialogBox(g_hInst, MAKEINTRESOURCE(IDD_DOCSETTING),
					  NULL, SettingDlgProc);
		}
		// ------------------------------------------------------
		// IPAhX̕\
		// ------------------------------------------------------
		char szHostName[32];
		szHostName[0] = '\0';

		int nResult = gethostname( szHostName, sizeof( szHostName ) );

		if( nResult != 0 ||  szHostName[0] == '\0' )
		{
			SetDlgItemText(hDlg, IDC_IPADDR, TEXT("0.0.0.0"));
			MessageBox(hDlg, TEXT("Socket Init Error."), TEXT("CEHTTP"), MB_ICONERROR);
			EndDialog(hDlg, 0);
			return TRUE;
		}

		HOSTENT* lphostent = gethostbyname( szHostName );
		if( lphostent == NULL )
		{
			SetDlgItemText(hDlg, IDC_IPADDR, TEXT("0.0.0.0"));
			MessageBox(hDlg, TEXT("Socket Init Error."), TEXT("CEHTTP"), MB_ICONERROR);
			return TRUE;
		}
		else
		{
			TCHAR szIpAddr[16];
			char* adr = *(lphostent->h_addr_list);
			wsprintf(szIpAddr, TEXT("%d.%d.%d.%d"), (UCHAR)adr[0], (UCHAR)adr[1], (UCHAR)adr[2], (UCHAR)adr[3] );
			SetDlgItemText(hDlg, IDC_IPADDR, szIpAddr);
		}
		// ------------------------------------------------------
		// T[oXbh̊Jn
		// ------------------------------------------------------
		pListenThreadPack = new THREADPACK;
		pListenThreadPack->bValid = FALSE;			// cold
		pListenThreadPack->hWnd = hDlg;				// hWnd for message
		pListenThreadPack->sock = INVALID_SOCKET;	// not use

		DWORD ThreadID;
		pListenThreadPack->hThread = CreateThread(NULL, 0, 
			(LPTHREAD_START_ROUTINE)thListen, (LPVOID)pListenThreadPack, 0, &ThreadID);

		// ------------------------------------------------------
		// ^XNgCACR̍쐬
		// ------------------------------------------------------
		nIcon.cbSize			= sizeof(nIcon);
		nIcon.hIcon				= (HICON)LoadImage(
										g_hInst,
										MAKEINTRESOURCE(IDI_ICON_MAIN),
										IMAGE_ICON, 16,16,0);
		nIcon.hWnd				= hDlg;
		nIcon.uCallbackMessage	= MY_NOTIFYICON;
		nIcon.uFlags			= NIF_MESSAGE | NIF_ICON;
		nIcon.uID				= 1;

		Shell_NotifyIcon(NIM_ADD, &nIcon);

		return TRUE;
	}

	case WM_CREATE:
	{
		SetWindowPos(hDlg, NULL, 0,0,0,0,SWP_NOMOVE|SWP_NOSIZE|SWP_HIDEWINDOW);
		return 0;
	}
	
	case MY_NOTIFYICON:
		switch(lParam)
		{
		case WM_LBUTTONDOWN:
		{
			static bShow = FALSE;
			if( bShow = !bShow )
			{
				ShowWindow(hDlg, SW_SHOW);
				SetForegroundWindow(hDlg);
			}
			else
			{
				ShowWindow(hDlg, SW_HIDE);
			}

			break;
		}
		default:
			break;
		}
		break;
	
	case WM_COMMAND:
		switch(LOWORD(wParam))
		{
		case IDOK:
			EndDialog(hDlg, 0);
			return TRUE;
		
		case IDCANCEL:
			ShowWindow(hDlg, SW_HIDE);
			return TRUE;

		case IDC_BTN_HIDE:
			ShowWindow(hDlg, SW_HIDE);
			return TRUE;

		case IDC_BTN_SETTING:
			DialogBox(g_hInst, MAKEINTRESOURCE(IDD_DOCSETTING), NULL, SettingDlgProc);
			return TRUE;
		}
		break;

	case WM_HELP:
			DialogBox(g_hInst, MAKEINTRESOURCE(IDD_HELP), NULL, HelpDlgProc);
			return TRUE;


	case WM_CLOSE:
		EndDialog(hDlg, 0);
		return TRUE;

	case WM_DESTROY:
		Shell_NotifyIcon(NIM_DELETE, &nIcon);
		// ListenXbh̏I҂ďI܂B
		if( pListenThreadPack )
		{
			pListenThreadPack->bValid = FALSE;
		
			if(WAIT_TIMEOUT == WaitForSingleObject(pListenThreadPack->hThread, 10000))
			{
				// ҂Ȃꍇ͋I
				TerminateThread(pListenThreadPack->hThread, 0);
			}

			CloseHandle(pListenThreadPack->hThread);
			delete pListenThreadPack;
		}
		return 0;
	}

	return FALSE;
}

//-----------------------------------------------------------------------------
//	@detail
//		ݒ_CAO
//	@param
//	@return
//-----------------------------------------------------------------------------
BOOL ShowSetting(HWND hDlg)
{
	TCHAR	tszValue[MAX_PATH];

	memset( tszValue, 0, sizeof(TCHAR)*(MAX_PATH) );

	// ----------------------------------------------------------
	// show document root
	MultiByteToWideChar(CP_ACP, 0, g_conf.m_pszDocRootName, -1, tszValue, MAX_PATH );
	SetDlgItemText(hDlg, IDC_DOCROOT, tszValue );

	// ----------------------------------------------------------
	// show cgi root
	MultiByteToWideChar(CP_ACP, 0, g_conf.m_pszCgiRootName, -1, tszValue, MAX_PATH );
	SetDlgItemText(hDlg, IDC_CGIROOT, tszValue );

	// ----------------------------------------------------------
	// show cgi root
	SetDlgItemInt(hDlg, IDC_LISTENPORT, g_conf.m_nListenPort, 0);

	return TRUE;
}

//-----------------------------------------------------------------------------
//	@detail
//		About_CAO֐
//	@param
//	@return
//-----------------------------------------------------------------------------
BOOL CALLBACK HelpDlgProc(HWND hDlg, UINT Msg, WPARAM wParam, LPARAM lParam)
{
	switch(Msg)
	{
	// ----------------------------------------------------------
	case WM_INITDIALOG:
	{
		TCHAR szBuf[512];
		*szBuf = '\0';

		wcscat(szBuf, TEXT("cehttp.cpp\r\n"));
		wcscat(szBuf, szG_VERSION_OF_CEHTTP_CPP );
		wcscat(szBuf, TEXT("\r\n"));

		wcscat(szBuf, TEXT("httpd.cpp\r\n"));
		wcscat(szBuf, szG_VERSION_OF_HTTPD_CPP );
		wcscat(szBuf, TEXT("\r\n"));
		
		wcscat(szBuf, TEXT("httphelper.cpp\r\n"));
		wcscat(szBuf, szG_VERSION_OF_HTTPHELPER_CPP );
		wcscat(szBuf, TEXT("\r\n"));
		
		wcscat(szBuf, TEXT("myconf.cpp\r\n"));
		wcscat(szBuf, szG_VERSION_OF_MYCONF_CPP );
		wcscat(szBuf, TEXT("\r\n"));
		
		wcscat(szBuf, TEXT("myhttpsock.cpp\r\n"));
		wcscat(szBuf, szG_VERSION_OF_MYHTTPSOCK_CPP );
		wcscat(szBuf, TEXT("\r\n"));
		
		wcscat(szBuf, TEXT("mysock.cpp\r\n"));
		wcscat(szBuf, szG_VERSION_OF_MYSOCK_CPP );
		wcscat(szBuf, TEXT("\r\n"));
		
		wcscat(szBuf, TEXT("mytime.cpp\r\n"));
		wcscat(szBuf, szG_VERSION_OF_MYTIME_CPP );
		wcscat(szBuf, TEXT("\r\n"));

		SetDlgItemText(hDlg, IDC_VERSIONS, szBuf);

		return TRUE;

	}
		return TRUE;
	// ----------------------------------------------------------
	case WM_COMMAND:
		switch(LOWORD(wParam))
		{
		case IDOK:
		case IDCANCEL:
			EndDialog(hDlg, 0);
			return TRUE;
		}
		break;

	// ----------------------------------------------------------
	case WM_CLOSE:
		EndDialog(hDlg, 0);
		return TRUE;
	}
	
	return FALSE;
}

//-----------------------------------------------------------------------------
//	@detail
//		ݒ_CAO֐
//	@param
//	@return
//-----------------------------------------------------------------------------
BOOL CALLBACK SettingDlgProc(HWND hDlg, UINT Msg, WPARAM wParam, LPARAM lParam)
{
	static	THREADPACK* pListenThreadPack = NULL;
	static	NOTIFYICONDATA	nIcon;
	static	HICON			hIconTaskBar;

	switch(Msg)
	{
	// ----------------------------------------------------------
	case WM_INITDIALOG:
	{
		ShowSetting(hDlg);
		return TRUE;
	}

	// ----------------------------------------------------------
	case WM_COMMAND:
		switch(LOWORD(wParam))
		{
		case IDOK:
			if( IDYES == 
				MessageBox(hDlg, TEXT("May I save this setup?"), 
					MYCONF_WSTR_SRVNAME, MB_YESNO|MB_ICONWARNING|MB_DEFBUTTON2 ) )
			{
				if( !SetSetting(hDlg) )
				{
					MessageBox(hDlg, TEXT("Save setup failed."), 
						MYCONF_WSTR_SRVNAME, MB_OK|MB_ICONERROR );
					return TRUE;
				}
			}
			EndDialog(hDlg, 0);
			return TRUE;
		
		case IDCANCEL:
			EndDialog(hDlg, 0);
			return TRUE;
		}
		break;

	// ----------------------------------------------------------
	case WM_CLOSE:
		EndDialog(hDlg, 0);
		return TRUE;
	}

	return FALSE;
}

//-----------------------------------------------------------------------------
//	@detail
//		ݒۑ
//	@param
//	@return
//-----------------------------------------------------------------------------
BOOL SetSetting(HWND hDlg)
{
	TCHAR	tszBuff[MAX_PATH];
	TCHAR*	pt;
	char	szDoc[MAX_PATH];
	char	szCgi[MAX_PATH];
	unsigned int unPort;

	// --------------------------------------------------------------
	// document root
	// --------------------------------------------------------------
	pt = (TCHAR*)memset( tszBuff, 0, sizeof(TCHAR)*MAX_PATH );
	GetDlgItemText(hDlg, IDC_DOCROOT, tszBuff, MAX_PATH-2);

	while( *pt != '\0' ){ pt++; }
	pt--;
	if( *pt == '\\' ){ *pt = '\0'; }
	
	WideCharToMultiByte(CP_ACP, 0, tszBuff, -1, szDoc, MAX_PATH, NULL, NULL);

	// --------------------------------------------------------------
	// extention root
	// --------------------------------------------------------------
	pt = (TCHAR*)memset( tszBuff, 0, sizeof(TCHAR)*MAX_PATH );
	GetDlgItemText(hDlg, IDC_CGIROOT, tszBuff, MAX_PATH-2);

	while( *pt != '\0' ){ pt++; }
	pt--;
	if( *pt == '\\' ){ *pt = '\0'; }
	
	WideCharToMultiByte(CP_ACP, 0, tszBuff, -1, szCgi, MAX_PATH, NULL, NULL);

	// --------------------------------------------------------------
	// listen port
	// --------------------------------------------------------------
	unPort = GetDlgItemInt(hDlg, IDC_LISTENPORT, NULL, FALSE);

	
	// --------------------------------------------------------------
	// save
	// --------------------------------------------------------------
	if( 0 != my_strnicmp( szDoc, szCgi, strlen( szDoc ) ) )
	{
		MessageBox(hDlg, TEXT(
			"Please be sure to place a ExtRoot under DocRoot."
			), MYCONF_WSTR_SRVNAME, MB_ICONHAND);
		return FALSE;
	}

	if( unPort < 1 || unPort > 0xFFFE )
	{
		MessageBox(hDlg, TEXT(
			"Listen port must be between 1 and 65534."
			), MYCONF_WSTR_SRVNAME, MB_ICONHAND);
		return FALSE;
	}

	if( !(g_conf.WriteStringValue(MYCONF_WSTR_KEY_DOCROOT, szDoc)) )
		return FALSE;

	if( !(g_conf.WriteStringValue(MYCONF_WSTR_KEY_CGIROOT, szCgi)) )
		return FALSE;

	if( !(g_conf.WriteIntValue(MYCONF_WSTR_KEY_PORT, unPort)) )
		return FALSE;

	//strcpy(g_conf.m_pszDocRootName, szDoc);
	//strcpy(g_conf.m_pszCgiRootName, szCgi);


	// --
	MakeLand(hDlg);
	MessageBox(hDlg, TEXT("This setup becomes effective after a restart."), MYCONF_WSTR_SRVNAME, MB_ICONINFORMATION);

	return TRUE;
}

//-----------------------------------------------------------------------------
//	@detail
//		h̍쐬
//		DocRootȂ΍
//	@param
//	@return
//-----------------------------------------------------------------------------
BOOL MakeLand(HWND hDlg)
{
	HANDLE fff;
	WIN32_FIND_DATA wfd;
	char	szFile[MAX_PATH];
	TCHAR	tszFile[MAX_PATH];

	char*	pszIndexPage =
		"<HTML><BODY><H1>Can you see me?</H1><BR><HR>CEHTTP2 by"
		"<A HREF=\"http://www001.upp.so-net.ne.jp/ishi/\">IshiSoft</A></BODY></HTML>";

	strcpy(szFile, g_conf.m_pszDocRootName);
	if( 0 == MultiByteToWideChar(CP_ACP,0,szFile,-1,tszFile, MAX_PATH) )
	{
		return FALSE;
	}

	// t@Č
	fff = FindFirstFile( tszFile, &wfd );

	if( fff == INVALID_HANDLE_VALUE ||
		(fff != INVALID_HANDLE_VALUE) && !(wfd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) )
	{
		if( IDNO == 
			MessageBox(hDlg, TEXT("May I create default directory?"), 
				MYCONF_WSTR_SRVNAME, MB_YESNO|MB_ICONQUESTION|MB_DEFBUTTON1 ) )
		{
			return FALSE;
		}
		// ------------------------------------------------
		// hLg[g̍쐬
		// ------------------------------------------------
		if( 0 == CreateDirectory( tszFile, NULL ) )
			return FALSE;
		// ------------------------------------------------
		// ftHghLg̍쐬
		// ------------------------------------------------
		strcat(szFile, "\\");
		strcat(szFile, g_conf.m_pszDefaultDocName);
		if( 0 == MultiByteToWideChar(CP_ACP,0,szFile,-1,tszFile, MAX_PATH) )
		{
			return FALSE;
		}
		HANDLE hFile = CreateFile(tszFile, 
			GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
		
		if( hFile == INVALID_HANDLE_VALUE )
			return FALSE;

		DWORD dwWritebytes;
		WriteFile(hFile, pszIndexPage, strlen(pszIndexPage), &dwWritebytes, NULL);
		CloseHandle(hFile);
		// ------------------------------------------------
		// CGI[g̍쐬
		// ------------------------------------------------
		strcpy(szFile, g_conf.m_pszCgiRootName);
		if( 0 == MultiByteToWideChar(CP_ACP,0,szFile,-1,tszFile, MAX_PATH) )
		{
			return FALSE;
		}
		if( 0 == CreateDirectory( tszFile, NULL ) )
			return FALSE;
	}
	else
	{
		FindClose(fff);
	}
	return TRUE;
}