// CEHTTP.cpp : AvP[Vp̃Gg |Cg̒`
//

#include "stdafx.h"
#include "resource.h"

#include <stdio.h>
#include "MyHttpSock.h"
#include "httpd.h"
#include "MyConf.h"
#include "httphelper.h"

TCHAR*	szG_VERSION_OF_HTTPD_CPP = TEXT(__TIMESTAMP__);

SERVER_INFO	g_ServerInfo;

// 萔
MyConf	g_conf;



#ifdef DEBUG
void DebugText(HWND hWnd, int nMsgID, int nHttpStatus, TCHAR* p)
{
	wsprintf(p, TEXT("%u"), nHttpStatus);
	SetDlgItemText(hWnd, nMsgID, p);
}
#endif

//-----------------------------------------------------------------------------
//	@detail
//		NCAgXbh
//	@param
//		THREADPACK
//	@return
//-----------------------------------------------------------------------------
void thAccept(LPVOID pvParams)
{
	// ------------------------------------------
	// Xbh̏
	// ------------------------------------------
	char szConnection[] = "connection";
	char szKeepAlive[] = "keep-alive";
	char szClose[] = "close";
	THREADPACK* ptpAcceptThread = (THREADPACK*)pvParams;
	MyHttpSock* s = new MyHttpSock();
	// [gzXg|C^Rs[
	s->m_hrHttpReq.psaRemoteHost = &ptpAcceptThread->saRemoteHost;
	s->m_pServerInfo = &g_ServerInfo;
	
	// ------------------------------------------
	// ANZvg[v
	// ------------------------------------------
	while(ptpAcceptThread->bValid != FALSE)
	{
		TCHAR	tszText[256];
		memset(tszText, 0, sizeof(TCHAR)*256);
		
		// M\PbgZbg
		s->SetSocket( ptpAcceptThread->sock );

			// @RFC2616 sec.8.1 Persistent connection
			// pipeline was not supported.
KEEP_ALIVE:
		s->SetTimeOut(1);	// 1sec timeout
		// ----------------------------------------------------------------
		// MJn
		// ----------------------------------------------------------------
		int nHttpStatus = s->RecvRequest(ptpAcceptThread->pbBeQuick);

#ifdef DEBUG
		// debug print
		DebugText(ptpAcceptThread->hWnd, ptpAcceptThread->nMsgID,nHttpStatus, tszText);
#endif

		if( nHttpStatus != 0 )	// 0==socket error
		{
			// ----------------------------------------------------------------
			// ԓ𑗂
			// ----------------------------------------------------------------
			s->SetTimeOut(5);	// 5sec timeout
			int bConnectionClose;

			char* pszCon = s->m_hashReqHeader.GetValueI(szConnection);
			if( pszCon == NULL )
			{
				pszCon = szKeepAlive;
			}

			// ----------------------------------------------------------------
			// Keep-Alive
			// 200 OKA304 Not Modified̏ꍇ
			// confݒ肳ĂƂ
			// 
			// ----------------------------------------------------------------
			// 200 OK304 
			// ----------------------------------------------------------------
			bConnectionClose = FALSE;
			if( !g_conf.m_nKeepAlive )						// Connection: close ݒ
			{
				bConnectionClose = TRUE;					// ݒɂ苭close
			}
			else
			{
															// łȂꍇ
				if(		0 == my_stricmp(pszCon, szClose ) ||	// Connection: close
						*ptpAcceptThread->pbBeQuick || 		// IM
						( nHttpStatus != 200 && nHttpStatus != 304 && nHttpStatus != 302 ))
															// 200 304łȂ
				{
					bConnectionClose = TRUE;
				}
			}

			 nHttpStatus = s->SendResponse(nHttpStatus, bConnectionClose);

#ifdef DEBUG
			// debug print
			DebugText(ptpAcceptThread->hWnd, ptpAcceptThread->nMsgID,nHttpStatus, tszText);
#endif

			if( nHttpStatus > 0 )
			{
				if( pszCon != NULL )
				{
					// }łȂȂKeep-Alive
					if( !bConnectionClose )
					{
						s->FreeMemory();
						goto KEEP_ALIVE;
					}
				}
			}
		}


		// ------------------------------------------
		// MI
		// Connection: close
		// ------------------------------------------
		s->FreeMemory();
		s->Close();

		// ------------------------------------------
		// TXyhđҋ@
		// ------------------------------------------
#ifdef DEBUG
		wcscat(tszText, TEXT("."));
		SetDlgItemText(ptpAcceptThread->hWnd, ptpAcceptThread->nMsgID, tszText);
#endif
		ptpAcceptThread->bValid = FALSE;
		SuspendThread( ptpAcceptThread->hThread );
	}
	delete s;
	ptpAcceptThread->bValid = FALSE;
	ExitThread(1);
}

//-----------------------------------------------------------------------------
//	@detail
//		T[oXbh
//	@param
//		THREADPACK
//	@return
//-----------------------------------------------------------------------------
void thListen(LPVOID pvParams)
{
	THREADPACK* ptpListenThread = (THREADPACK*)pvParams;
	THREADPACK* ptpAcceptThread = new THREADPACK[g_conf.m_nStartServers];
	THREADPACK* pTP;

	static	int	bBeQuick = FALSE;

	// T[oݒ[h
	g_ServerInfo.nPort			= g_conf.m_nListenPort;
	g_ServerInfo.pszCgiRootName	= g_conf.m_pszCgiRootName;
	g_ServerInfo.pszDocRootName	= g_conf.m_pszDocRootName;
	g_ServerInfo.pszSoftware		= g_conf.m_pszServerSoftware;
	g_ServerInfo.pszDefaultDocName = g_conf.m_pszDefaultDocName;
	g_ServerInfo.pszAccessFileName = g_conf.m_pszAccessFileName;

	// T[oXbhJn
	ptpListenThread->bValid = TRUE;

	int ii = 0;

	// ------------------------------------------
	// Jn
	// ------------------------------------------
	MySock s;

	if( SOCKET_ERROR == s.Listen(g_ServerInfo.nPort) )
	{
		SetDlgItemText(ptpListenThread->hWnd, IDC_MESSAGE, TEXT("Listen Failed."));
		delete[] ptpAcceptThread;
		ptpListenThread->bValid = FALSE;
		ExitThread(0);
	}
	SetDlgItemText(ptpListenThread->hWnd, IDC_MESSAGE, TEXT("Listen..."));
	
	// ------------------------------------------
	// qXbhǗpϐ
	// ------------------------------------------
	pTP = ptpAcceptThread;
	for( ii = 0; ii < g_conf.m_nStartServers; ii++, pTP++ )
	{
		pTP->bValid = FALSE;
		pTP->pbBeQuick = &bBeQuick;
		pTP->hWnd = ptpListenThread->hWnd;
		pTP->hThread = NULL;
		pTP->sock = INVALID_SOCKET;
		pTP->nMsgID = IDC_THREAD0 + ii;
	}

	// ------------------------------------------
	// qXbh̍쐬
	// ------------------------------------------
	pTP = ptpAcceptThread;
	for( ii = 0; ii < g_conf.m_nStartServers; ii++, pTP++ )
	{
		DWORD ThreadID;
		pTP->hThread = CreateThread(
			NULL, 0, (LPTHREAD_START_ROUTINE)thAccept, 
			(LPVOID)pTP, CREATE_SUSPENDED, &ThreadID);
		SetDlgItemText(ptpListenThread->hWnd, IDC_THREAD0 + ii, TEXT("Ready."));
		
		if( pTP == NULL )
		{
			delete[] ptpAcceptThread;
			ExitThread(0);
		}
	}
	
	// ------------------------------------------
	// M[`
	// ------------------------------------------
	while(ptpListenThread->bValid)
	{
		SOCKET client_socket;
		sockaddr_in saRemoteHost;

		pTP = ptpAcceptThread;
		if( s.IsReadalbe() > 0 )
		{
			// 󂢂ĂqXbhT
			for( ii = 0; ii < g_conf.m_nStartServers; ii++, pTP++ )
			{
				if( pTP->bValid == FALSE )
				{
					bBeQuick = FALSE;
					
					// Xbh̂ŃANZvg
					// ACCEPT
					// DlgĂяoɂďIł悤1bŃ^CAEg`FbN
					client_socket = s.Accept(&saRemoteHost);
					
					if( client_socket == INVALID_SOCKET )
						break;

					// ϐZbgAXbhN
					pTP->bValid = TRUE;
					pTP->sock = client_socket;
					memcpy(&(pTP->saRemoteHost), &saRemoteHost, sizeof(sockaddr_in) );
					ResumeThread(pTP->hThread);
					break;
				}
			}
			// NȂ
			if( ii >= g_conf.m_nStartServers )
			{
				// Keep-AliveĂ߂悤Ɏw
				bBeQuick = TRUE;
			}
		}
		else
		{
			// Save CPU power.
			Sleep(100);
		}
		continue;
	}

	HANDLE*	phThreads = new HANDLE[g_conf.m_nStartServers];

	for( ii = 0, pTP = ptpAcceptThread; ii < g_conf.m_nStartServers; ii++, pTP++ )
	{
		//hThreads[ii] = pTP->hThread;
		phThreads[ii] = pTP->hThread;
		pTP->bValid = FALSE;
		ResumeThread(pTP->hThread);
	}

	// ------------------------------------------
	// SẴXbhI
	// ------------------------------------------
	WaitForMultipleObjects( g_conf.m_nStartServers, phThreads, TRUE, 3000 );

	for( ii = 0, pTP = ptpAcceptThread; ii < g_conf.m_nStartServers; ii++, pTP++ )
	{
		if( pTP->hThread )
			CloseHandle( pTP->hThread );
	}

	delete[] phThreads;
	delete[] ptpAcceptThread;
	ExitThread(1);
}
